function H = estimate_H(data_mat, thresh)

    n_samples = size(data_mat, 1);
    
    
    first_estsize = 4;
    second_estsize = 8;
    n_tries = 11;
    
    best_H = [];
    best_inlier_count = 0;
    
    for i=1:n_tries
        %r=rand(1,n_samples);
        %[dc,p]=sort(r);
        p=randperm(n_samples);
        idx=p(1:first_estsize);
        
        HI = vgg_H_from_x_lin(data_mat(idx, 1:3)', data_mat(idx, 4:6)');
        if cond(HI) > 1000000
            continue
        end
        H = inv(HI);

        d12 = symerr(data_mat, H, HI);
        inlier_idx = find(d12 < thresh);

        if (numel(inlier_idx) > second_estsize)
            HI = vgg_H_from_x_lin(data_mat(inlier_idx, 1:3)', data_mat(inlier_idx, 4:6)');
            if cond(HI) > 1000000
               continue
            end
            H = inv(HI);

            d12 = symerr(data_mat, H, HI);
            inlier_idx = find(d12 < thresh);
            
            if numel(inlier_idx) > best_inlier_count
                best_inlier_count = numel(inlier_idx);
                best_H = H;
            end
        end    
    end
    
    if best_inlier_count == 0
        H = zeros(3,3);
    else
        H = best_H;
    end
    
    