function [x, n_elements]=jcorr(idx, d)

% [x, n_elements]=jcorr(idx, d)
% 
% idx: class labels from classification
% d: Jaccard Dinstance with unknown data as nan
% x: nominator of C(i,j(n) (Eq. (11))
% n_elements: denominator of C(i,j(n) (Eq. (11))

N=max(idx);
x=zeros(N);
n_elements=zeros(N);

for i=1:N
    
    idx_i = i == idx;
    
    for j=1:N
    
        idx_j = j == idx;
        
        this_d = d(idx_i, idx_j);
        valid = ~isnan(this_d); % fadout operator
        x(i,j) = sum(reshape(this_d(valid), 1, []));
        n_elements(i,j) = nnz(valid); % normalization
        

    end
end

