function [idx, combined_residual_mat] = msam(data_mat, debug)

% idx = msam(data_mat [, debug=0])
    
if nargin < 2
    debug = 0;
end

assert(size(data_mat,2) == 6);
msam_globals;

idx=ones(1, size(data_mat,1));

if debug
    clf
    plot_classes(idx, data_mat);
end

for iter = 1:100
    %%
    [idx_after] = split_and_merge_clusters(data_mat, idx, thresh);
                
    if (debug)
        figure(10);
        clf;
        plot_classes(idx_after, data_mat);
        pause
    end
 
    
    if idx_after == idx
      break;
    else
      idx = idx_after;
    end
end

fprintf('Finished in %d iterations\n', iter);

if nargout > 1
    %% create residual matrix
    possible_classes = unique(idx_after);
    if possible_classes(1) == 0; possible_classes = possible_classes(2:end); end;
    
    combined_residual_mat=false(numel(possible_classes), size(data_mat, 1));
    for i=1:numel(possible_classes)
        i_idx = find(idx == possible_classes(i));
        [dc,inlier_idx] = class_homogenity(data_mat, thresh, i_idx, 1:size(data_mat,1));
        combined_residual_mat(i,inlier_idx) = true;
    end
end



