function plot_segmentation2 (sq_residuum_mat, traj_ids, class_label, ...
                            row_labels, outl_thresh, d, ...
                            frames, trajs, savedir)
    
    n_classes = max(class_label);
    
    %% draw residuum
    figure(1)
    clf
    plot_residuum_mat(class_label, sqrt(sq_residuum_mat), traj_ids, outl_thresh, row_labels);
    if exist('savedir', 'var')
        outfile=sprintf('%s/cluster-residuum.eps', savedir);
        saveas(gcf, outfile);
    end

    %% draw clustering
    figure(2);
    clf;
    plot_segmentation_result(d, class_label, traj_ids);
    if exist('savedir', 'var')
        outfile=sprintf('%s/cluster-segmentation.eps', savedir);
        saveas(gcf, outfile);
    end
    
    %% Draw in destination images
    for i=2:numel(frames) 
        f1=frames(i-1);
        f2=frames(i);
        data = [trajs(:,:,f1)', trajs(:,:,f2)'];
        [known_data,dc]=find(~isnan(data));
        known_data=unique(known_data);
        
        figure(3);
        clf;
        plot_classes(class_label(known_data), data(known_data,:));
        title(sprintf('frame %d', f2));
        axis equal;
        
        %% create output
        if exist('savedir', 'var')
            outfile=sprintf('%s/cluster-%d-%08d.png', savedir, n_classes, f2);
            print('-dpng', '-r100', outfile)
        else
            pause
        end

    end

