function [Y,IDX,C,d,intra_d,inter_d,LMat,intra_inter_ratio] = ...
    sc_sym(affMat,k,clustering)

% [Y,IDX,errorsum,affMat,C]= ...
%    sc_sym(affMat,k,clustering)

assert(nnz(diag(affMat) == 0) == 0); % check if we really have an
                                     % affinity matrix (or a distance matrix)
assert(isequal(affMat,affMat'));
assert(numel(k) == 1);

num_class=k;
numDT=size(affMat,2);

fprintf('Regular clustering matrix of size %dx%d into %d classes using %d eigenvectors\n', size(affMat, 1), ...
        size(affMat, 2), num_class, k);

diagMatDiag = sum(affMat,2).^(-1./2);
diagMat= sparse(1:numDT, 1:numDT, diagMatDiag); % L_sym
LMat=diagMat*affMat*diagMat;
LMat=(LMat+LMat')/2;
% => nicht die kleinsten k, sondern dir größten (ab 1)
assert(isequal(LMat,LMat'));

fprintf('Finding %d eigenvectors.\n', k);
opts.disp=0;
[v,d]=eigs(LMat,k,'LA',opts);


%get the idicator vectors and normalize them to row norm 1
X=v(:,1:k);
normX=(sum(X.^2,2)).^(1./2);
Y=zeros(size(X));
for index=1:numDT
    Y(index,:)=X(index,:)./normX(index,1);
end

switch clustering
  case 'kmeans'
    %%
    [IDX,C,intra_d] = kmeans(Y,num_class,'EmptyAction','drop','Replicates',10);%,'Distance','correlation');
    intra_d=intra_d'; 
 case 'kmeans2'
     %%
  params.minCl=0.001 * numDT;
  %params.display=1;
  params.nTrial=100;
  params.maxIter=1000;
  params.outFrac=0;
  %params.metric='cosine';
  [IDX,C] = kmeans2(Y, num_class, params);

  for i=1:k
    intra_d(i) = mean(reshape(pdist2(Y(IDX==i,:), C(i)),1,[]));   
  end
 case 'N'
   IDX=1:k;
   C=Y;
   intra_d=zeros(1,k);
   for i=1:k
     inter_d(i) = mean(reshape(pdist2(Y(i,:), Y([1:i-1, i+1:k],:)), 1, []));       
    end
return
end


for i=1:k
    inter_d(i) = mean(reshape(pdist2(Y(IDX==i,:), Y(IDX~=i,:)), 1, []));       
end
intra_inter_ratio = mean(intra_d ./ inter_d);
